<template>
  <Form ref="form" v-slot="{ handleSubmit, values, meta }" :initialValues="initialValues">
       <div class="v-chart-account-form px-[40px] py-[30px]">
          <div class="grid gap-4 mb-4 md:grid-cols-3">
              <div>
                  <Field name="fullName" type="text" v-slot="{ value, errorMessage, handleChange }" filterable rules="required">
                      <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                          Full Name <span class="sign">*</span></label>
                      <el-form-item :error="errorMessage">
                          <el-input :model-value="value" @update:model-value="handleChange" placeholder="Full Name" />
                      </el-form-item>
                  </Field>
              </div>
              <div>
                  <Field name="username" type="text" v-slot="{ value, errorMessage, handleChange }" filterable rules="required">
                      <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                          User Name <span class="sign">*</span></label>
                      <el-form-item :error="errorMessage">
                          <el-input :model-value="value" @update:model-value="handleChange" placeholder="User Name" />
                      </el-form-item>
                  </Field>
              </div>
              <div>
                  <Field name="phoneNumber" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                      <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                            Phone Number</label>
                        <el-form-item :error="errorMessage">
                            <el-input :model-value="value" @update:model-value="handleChange" placeholder=" Phone Number" />
                      </el-form-item>
                  </Field>
              </div>
          </div>

        <div class="grid gap-4 mb-4 md:grid-cols-3">
              <div>
                  <Field name="companySessionId" type="text" v-slot="{ value, errorMessage, handleChange }" rules="required"
                      :items="projects" filterable>
                      <label class="block text-sm font-medium text-gray-900">Company Session <span class="sign">*</span>
                          <el-form-item :error="errorMessage">
                              <el-select @change="onFetchVendor" :disabled="isReadonly" :model-value="value"
                                  @update:model-value="handleChange" class="w-[100%] mt-2" placeholder="Select a company session"
                                size="large" clearable>
                                <!-- <el-option v-for="(item, i)  in company" :key="i" :label="item.companyNameEn" :value="item.id" /> -->
                                <el-option v-for="(item, i) in [                                      
                                  { name: 'LHP-0001', value: 'LHP-0001' },
                                  { name: 'LHP-0002', value: 'LHP-0002' },
                                  { name: 'LHP-0003', value: 'LHP-0003' },
                                  { name: 'LHP-0004', value: 'LHP-0004' },
                              ]" :key="i" :label="item.name"
                                  :value="item.value" />
                              </el-select>
                          </el-form-item>
                      </label>
                </Field>
              </div>
              <div>
                      <Field name="userGroupId" type="text" v-slot="{ value, errorMessage, handleChange }" rules="required"
                          :items="projects" filterable>
                          <label class="block text-sm font-medium text-gray-900">User Group <span class="sign">*</span>
                            <el-form-item :error="errorMessage">
                              <el-select @change="onFetchVendor" :disabled="isReadonly" :model-value="value"
                                @update:model-value="handleChange" class="w-[100%] mt-2" placeholder="Select user group" size="large"
                                clearable>
                                <!-- <el-option v-for="(item, i) in userGroup" :key="i" :label="item.name" :value="item.id" /> -->
                                <el-option v-for="(item, i) in [                                      
                                  { name: 'Admind', value: 'Admin' },
                                  { name: 'Chife of Finance', value: 'Chife Finance' },
                                  { name: 'Head of Finance', value: 'Head of Finance' },
                                  { name: 'Developer', value: 'Developer' },
                              ]" :key="i" :label="item.name"
                                  :value="item.value" />
                              </el-select>
                            </el-form-item>
                          </label>
                    </Field>
              </div>
              <div>
                <Field name="telegramId" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                  <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                    Telegram</label>
                  <el-form-item :error="errorMessage">
                    <el-input :model-value="value" @update:model-value="handleChange" placeholder="Telegram" />
                  </el-form-item>
                </Field>
              </div>
           </div>

           <div class="grid gap-4 mb-4 md:grid-cols-3">
            <div>
              <Field name="email" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                  Email</label>
                <el-form-item :error="errorMessage">
                  <el-input :model-value="value" @update:model-value="handleChange" placeholder="Email" />
                </el-form-item>
              </Field>
            </div>
            <div>
              <Field name="posId" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                  Position</label>
                <el-form-item :error="errorMessage">
                  <el-input :model-value="value" @update:model-value="handleChange" placeholder="Position" />
                </el-form-item>
              </Field>
            </div>
            <div>
              <Field name="departmentId" type="text" v-slot="{ value, errorMessage, handleChange }" rules="required">
                <label class="block mb-2 text-sm font-medium text-gray-900" for="contractId">Departments <span
                    class="sign">*</span>
                  <el-form-item :error="errorMessage">
                    <el-select :model-value="value" @update:model-value="handleChange" filterable class="w-[100%] mt-2"
                      placeholder="Select Departments" size="large" clearable>
                      <!-- <el-option v-for="(item, i) in department" :key="i" :label="item.name" :value="item.value" /> -->
                      <el-option v-for="(item, i) in [                                      
                                  { name: 'Admind', value: 'Admin' },
                                  { name: 'Chife of Finance', value: 'Chife Finance' },
                                  { name: 'Head of Finance', value: 'Head of Finance' },
                                  { name: 'Developer', value: 'Developer' },
                              ]" :key="i" :label="item.name"
                                  :value="item.value" />
                    </el-select>
                  </el-form-item>
                </label>
              </Field>
            </div>
         </div>
          
          <div class="flex justify-center">
              <el-button v-if="!isReadonly" @click="handleSubmit($event, onSubmit(values, meta))"
                  class="bg-blue-700 hover:bg-blue-600 rounded-full ml-2 px-3 py-4 w-[100px]" size="large"
                  color="#1d4ed8">
                  Save
              </el-button>
          </div>
      </div>
  </Form>
</template>
<script>
import { ref } from "vue";
import { Form, Field } from "vee-validate";

export default {
  name: 'v-user-form',
  components: {
      Field,
      Form,
  },
  props: {
      data: {
          type: Object,
          default: () => ({}),
      },
      isEdit: {
          type: Boolean,
          default: false,
      },
  },

  emits: ["submit"],
  setup(props, { emit }) {
      const form = ref();
      const initialValues = props?.data || {};

      const onSubmit = (values, meta) => {
          if (meta.valid) {
              emit("submit", values);
          }
      };

      return {
          initialValues,
          form,
          onSubmit,
         
      }
  }
}
</script>